unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, Printers, ComCtrls, uAbout;

type
  TfCPUID = class(TForm)
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    Panel1: TPanel;
    Label1: TLabel;
    Label6: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Logo1: TImage;
    Logo2: TImage;
    LogoTimer: TTimer;
    BitBtn1: TBitBtn;
    PrintDialog: TPrintDialog;
    SaveDialog: TSaveDialog;
    procedure BitBtn3Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure LogoTimerTimer(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Logo1Click(Sender: TObject);
    procedure Logo2Click(Sender: TObject);
  end;

const
     dpCrLf = Chr(13)+ Chr(10);

var
  fCPUID: TfCPUID;
  posAdd: Integer;
  CPUReport: TextFile;
  LogoFlag :Boolean;
  ReportPrint: AnsiString;
  PrintRec: TRect;
  OldCaption: AnsiString;

implementation

uses Profiles;

{$R *.DFM}

type
	TCPUID	= array[1..4] of Longint;
	TVendor	= array [0..11] of char;

function GetCPUID : TCPUID; assembler; register;
asm
  PUSH    EBX         {Save affected register}
  PUSH    EDI
  MOV     EDI,EAX     {@Resukt}
  MOV     EAX,1
  DW      $A20F       {CPUID Command}
  STOSD			          {CPUID[1]}
  MOV     EAX,EBX
  STOSD               {CPUID[2]}
  MOV     EAX,ECX
  STOSD               {CPUID[3]}
  MOV     EAX,EDX
  STOSD               {CPUID[4]}
  POP     EDI					{Restore registers}
  POP     EBX
end;

function GetCPUVendor : TVendor; assembler; register;
asm
  PUSH    EBX					{Save affected register}
  PUSH    EDI
  MOV     EDI,EAX			{@Result (TVendor)}
  MOV     EAX,0
  DW      $A20F				{CPUID Command}
  MOV     EAX,EBX
  XCHG		EBX,ECX     {save ECX result}
  MOV			ECX,4
@1:
  STOSB
  SHR     EAX,8
  LOOP    @1
  MOV     EAX,EDX
  MOV			ECX,4
@2:
  STOSB
  SHR     EAX,8
  LOOP    @2
  MOV     EAX,EBX
  MOV			ECX,4
@3:
  STOSB
  SHR     EAX,8
  LOOP    @3
  POP     EDI					{Restore registers}
  POP     EBX
end;

procedure TfCPUID.BitBtn3Click(Sender: TObject);
begin
     if (SaveDialog.Execute) then
     begin
          AssignFile(CPUReport,SaveDialog.FileName);
          ReWrite(CPUReport);
          Write(CPUReport,ReportPrint);
          Flush(CPUReport);
          CloseFile(CPUReport);
     end;
end;


procedure TfCPUID.FormActivate(Sender: TObject);
var
  CPUID : TCPUID;
  I     : Integer;
  S     : TVendor;
begin
     LogoFlag := False;
     Logo2.Top := Logo1.Top;
     Logo2.Left := Logo1.Left;
     Logo2.Width := Logo1.Width;
     Logo2.Height := Logo1.Height;
     for I := Low(CPUID) to High(CPUID)  do CPUID[I] := -1;
     CPUID	:= GetCPUID;
     Label1.Caption := 'CPUID[1] = ' + IntToHex(CPUID[1],8);
     Label2.Caption := 'CPUID[2] = ' + IntToHex(CPUID[2],8);
     Label3.Caption := 'CPUID[3] = ' + IntToHex(CPUID[3],8);
     Label4.Caption := 'CPUID[4] = ' + IntToHex(CPUID[4],8);
     S := GetCPUVendor;
     fCPUID.Caption := fCPUID.Caption + ' - ' + S + ' Inside' ;
     Application.Title := fCPUID.Caption;
     Label5.Caption := 'Producer = ' + S;

     PrintRec := Rect(10,10,3600,2400);
     ReportPrint :='****************************' + dpCrLf +
                   '* Welcome coping Cpuid.exe *' + dpCrLf +
                   '****************************' + dpCrLf +
                   dpCrLf +
                   'CPU Check Date=' + DateToStr(Now)  + dpCrLf +
                   'CPU Check Time=' + TimeToStr(Now) + dpCrLf +
                   dpCrLf +
                   'CPU attributes listed:' + dpCrLf +
                   '    ' + Label1.Caption  + dpCrLf +
                   '    ' + Label2.Caption  + dpCrLf +
                   '    ' + Label3.Caption  + dpCrLf +
                   '    ' + Label4.Caption  + dpCrLf +
                   '    ' + Label5.Caption  + dpCrLf +
                   dpCrLf +
                   'Programmed by Mario Hsu' + dpCrLf +
                   '              in 1998/11/14' + dpCrLf +
                   '      updated in 1999/09/29';

    {Add fpr dos command line 1999/09/29}
    if (ParamCount() > 0) then
    begin
          AssignFile(CPUReport,ParamStr(1));
          ReWrite(CPUReport);
          Write(CPUReport,ReportPrint);
          Flush(CPUReport);
          CloseFile(CPUReport);
          Close();
    end;
end;

procedure TfCPUID.LogoTimerTimer(Sender: TObject);
begin
     if (LogoFlag) then
        begin
          Logo1.Visible := False;
          Logo2.Visible := True;
          LogoFlag := False;
        end
     else
        begin
          Logo1.Visible := True;
          Logo2.Visible := False;
          LogoFlag := True;
        end;
end;

procedure TfCPUID.BitBtn4Click(Sender: TObject);
type
   ReportString = array[1..15] of string;

var
   RS: ReportString;
   ReportLine: Longint;
   LineSpace: Longint;
   PrintFlag: Boolean;
   PrintCopies: Longint;

begin
     RS[1] :='';
     RS[2] :='          ' + 'Welcome coping Cpuid.exe';
     RS[3] :='';
     RS[4] :='';
     RS[5] :='CPU Check Date=' +  DateToStr(Now);
     RS[6] :='CPU Check Time=' +  TimeToStr(Now);
     RS[7] :='';
     RS[8] :='CPU attributes listed:';
     RS[9] :='          ' + Label1.Caption;
     RS[10] :='          '+ Label2.Caption;
     RS[11] :='          ' + Label3.Caption;
     RS[12] :='          ' + Label4.Caption;
     RS[13] :='          ' + Label5.Caption;
     RS[14] :='';
     RS[15] :='Programmed by Mario Hsu in 1997/11/14';
     PrintFlag := PrintDialog.Execute;
     if (PrintFlag) then
     begin
          Screen.Cursor := crHourGlass;

          for PrintCopies := 1 to PrintDialog.Copies do
          begin
            Printer.BeginDoc;
            Printer.Canvas.Rectangle(990,60,2105,1205);
            Printer.Canvas.Rectangle(995,65,2100,1200);
            Printer.Canvas.Rectangle(995,65,2100,264);
            Printer.Canvas.Font.Name := 'Arail';
            Printer.Canvas.Font.Size := 12;
            LineSpace := 72;
                for ReportLine := 1 to 15 do
                    Printer.Canvas.TextOut
                    (1000,ReportLine*LineSpace,RS[ReportLine]);
          Printer.EndDoc;
          end;

          Screen.Cursor := crDefault;
     end;
end;

procedure TfCPUID.BitBtn1Click(Sender: TObject);
begin
     fProfiles.ShowModal;
end;

procedure TfCPUID.Logo1Click(Sender: TObject);
begin
     frmAbout.ShowModal;
end;

procedure TfCPUID.Logo2Click(Sender: TObject);
begin
     frmAbout.ShowModal;
end;

end.
